(CXX)=g++
CFLAGS=-Wall -g
Progname=exercise_05_23
SOURCE_DIR:=sources
BUILD_DIR:=build
PRES_DIR:=$(BUILD_DIR)/pres
ASS_DIR:=$(BUILD_DIR)/assembler
OBJS_DIR:=$(BUILD_DIR)/obj

SOURCES:=$(wildcard $(SOURCE_DIR)/*.cpp)
PRES:=$(patsubst $(SOURCE_DIR)/%.cpp, $(PRES_DIR)/%.ii, $(SOURCES))
ASS:=$(patsubst $(SOURCE_DIR)/%.cpp, $(ASS_DIR)/%.s, $(SOURCES))
OBJS:=$(patsubst $(SOURCE_DIR)/%.cpp, $(OBJS_DIR)/%.o, $(SOURCES))
.SECONDARY: $(PRES) $(ASS)

$(Progname): $(OBJS)
	@echo Linking $?...
	@$(CXX) $(CFLAGS) $? -o $@

$(OBJS_DIR)/%.o: $(ASS_DIR)/%.s
	@echo Compiling $?... 
	@$(CXX)  -c $? -o $@

$(ASS_DIR)/%.s: $(PRES_DIR)/%.ii
	@echo Assembling $?...
	@$(CXX)  -S $? -o $@

$(PRES_DIR)/%.ii: $(SOURCE_DIR)/*.cpp $(BUILD_DIR) 
	@echo Pre-Processing $<...
	@$(CXX) -E $< -o $@

$(BUILD_DIR):
	mkdir $(BUILD_DIR)
	mkdir $(PRES_DIR)
	mkdir $(ASS_DIR)
	mkdir $(OBJS_DIR)

clean:
	@echo Cleaning...
	@rm -rf $(BUILD_DIR) exercise_05_23
